; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    tdata STRUCT
      pbuffer dd ?      ; buffer address
      bufsize dd ?      ; buffer size
      flag    dd ?
    tdata ENDS

    start_fill_thread PROTO :DWORD
    fill_thread  PROTO :DWORD

    .data?
      signal1 dd ?
      signal2 dd ?
      loaded  dd ?

    .code

start:
   
; 

    call main
    inkey
    exit

; 

    memcnt equ <1024*1024*100>

main proc

    LOCAL pmem1     :DWORD
    LOCAL pmem2     :DWORD
    LOCAL thread1   :DWORD
    LOCAL thread2   :DWORD
    LOCAL tdat      :tdata

    mov pmem1, alloc(memcnt)                        ; alocate 2 blocks of memory
    mov pmem2, alloc(memcnt)

  ; -------------------
  ; start 2 new threads
  ; -------------------
    mov eax, pmem1
    mov DWORD PTR tdat.pbuffer, eax
    mov DWORD PTR tdat.bufsize, memcnt                  ; 100 meg buffer
    mov DWORD PTR tdat.flag, OFFSET signal1
    mov thread1, rv(start_fill_thread,ADDR tdat)        ; start new thread

    mov eax, pmem2
    mov DWORD PTR tdat.pbuffer, eax
    mov DWORD PTR tdat.bufsize, memcnt                  ; 100 meg buffer
    mov DWORD PTR tdat.flag, OFFSET signal2
    mov thread2, rv(start_fill_thread,ADDR tdat)        ; start new thread

  ; **********************
  ; **********************

    print "-----------------",13,10
    print "Two thread tining",13,10
    print "-----------------",13,10

    invoke GetTickCount
    push eax

    REPEAT 8

  ; ||||||||||||||||||||||||||||||||||||||||||||||||
  ; fill pmem2 while working on pmem1
    invoke ResumeThread,thread2                         ; activate thread 2
  ; ||||||||||||||||||||||||||||||||||||||||||||||||

  ; ************************************
  ; do your own processing here on pmem2
  ; ************************************
    xor esi, esi
    mov edi, pmem1
  @@:
    mov [edi], esi
    add edi, 4
    add esi, 1
    cmp esi, (1024*1024*25)
    jl @B
  ; ************************************

  @@:
    cmp signal2, 0                                      ; test if thread is finished yet
    je @F
    invoke SleepEx,0,0
    jmp @B
  @@:
    ;;; print "fill 2 finished",13,10

    invoke ResumeThread,thread1                         ; activate thread 1
  ; ||||||||||||||||||||||||||||||||||||||||||||||||
  ; fill pmem1 while working on pmem2
  ; ||||||||||||||||||||||||||||||||||||||||||||||||

  ; ************************************
  ; do your own processing here on pmem1
  ; ************************************
    xor esi, esi
    mov edi, pmem2
  @@:
    mov [edi], esi
    add edi, 4
    add esi, 1
    cmp esi, (1024*1024*25)
    jl @B
  ; ************************************

  @@:
    cmp signal1, 0                                      ; test if thread is finished yet
    je @F
    invoke SleepEx,0,0
    jmp @B
  @@:
    ;;; print "fill 1 finished",13,10

  ; ||||||||||||||||||||||||||||||||||||||||||||||||

    ENDM

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print str$(eax)," ms duration",13,10

  ; **********************
  ; **********************

    print "-----------------",13,10
    print "One thread tining",13,10
    print "-----------------",13,10

    invoke GetTickCount
    push eax

  REPEAT 16

    invoke memfill,pmem1,memcnt,0

  ; ************************************
  ; do your own processing here on pmem1
  ; ************************************
    xor esi, esi
    mov edi, pmem1
  @@:
    mov [edi], esi
    add edi, 4
    add esi, 1
    cmp esi, (1024*1024*25)
    jl @B
  ; ************************************

  ENDM

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    print str$(eax)," ms duration",13,10

  ; **********************
  ; **********************

    invoke TerminateThread,thread1,0
    invoke TerminateThread,thread2,0

    free pmem2
    free pmem1

    ret

main endp

; 

start_fill_thread proc pstruct:DWORD

    LOCAL tID    :DWORD
    LOCAL thread :DWORD
    LOCAL lflag  :DWORD

    mov loaded, 0                       ; clear the loaded flag

    mov thread, rv(CreateThread,0,0,fill_thread,pstruct,0,ADDR tID)

  spinlock:
    invoke SleepEx,0,0
    cmp loaded, 1
    jne spinlock

    print "Thread started",13,10

    mov eax, thread

    ret

start_fill_thread endp

; 

fill_thread proc pstruct:DWORD

  ; -------------------------------------------------------------
  ; NOTE this thread is an infinite loop, it is eventually closed
  ; by the calling process using TerminateThread(). In these
  ; circumstances the EBX ESI EDI registers do not need to be
  ; preserved as the thread never returns to the operating system
  ; -------------------------------------------------------------
    LOCAL pbuf  :DWORD                          ; local buffer pointer
    LOCAL sbuf  :DWORD                          ; local buffer size variable

    mov edi, pstruct

    mov eax, (tdata PTR [edi]).pbuffer          ; copy pointer to LOCAL
    mov pbuf, eax
    mov eax, (tdata PTR [edi]).bufsize          ; copy size to LOCAL
    mov sbuf, eax
    mov esi, (tdata PTR [edi]).flag             ; copy flag to ESI
    mov DWORD PTR [esi], 1                      ; set the signal flag

    mov loaded, 1                               ; set the loaded flag for the calling proc

  @@:
  ; *****************************************
    invoke SuspendThread,rv(GetCurrentThread)   ; suspend until next external
    invoke memfill,pbuf,sbuf,0                  ; ResumeThread() is called.
    mov DWORD PTR [esi], 0                      ; clear the signal flag
    jmp @B
  ; *****************************************

    ret

fill_thread endp

; 


end start

























